/*******************************************************************************
 * Copyright (c) 2011, 2012 IBM Corporation and others.
 *
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *  
 *  The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 *  and the Eclipse Distribution License is available at
 *  http://www.eclipse.org/org/documents/edl-v10.php.
 *  
 *  Contributors:
 *  
 *	   Sam Padgett	       - initial API and implementation
 *     Michael Fiedler     - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.assume.adaptors.gitlab;

// Start of user code imports

import com.hp.hpl.jena.update.UpdateProcessor;
import org.apache.wink.json4j.JSONException;
import org.apache.wink.json4j.JSONObject;
import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.tools.store.ModelUnmarshallingException;
import org.eclipse.lyo.tools.store.Store;
import org.eclipse.lyo.tools.store.StoreAccessException;
import org.eclipse.lyo.tools.store.StoreFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import se.kth.md.aide.repository.api.Revision;
import se.kth.md.assume.adaptors.gitlab.extractors.ResourceExtractorHelper;
import se.kth.md.assume.adaptors.gitlab.repository.ResourceVersionHandler;
import se.kth.md.assume.adaptors.gitlab.resources.*;
import se.kth.md.assume.adaptors.gitlab.servlet.ServiceProviderCatalogSingleton;
import se.kth.md.assume.adaptors.gitlab.updates.GitlabEventMessage;
import se.kth.md.assume.repository.update.RepositoryResourceManager;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.http.HttpServletRequest;
import java.io.BufferedReader;
import java.io.IOException;
import java.net.URI;
import java.time.ZonedDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.concurrent.ExecutionException;

// End of user code

// Start of user code pre_class_code
// End of user code

public class GitLabManager {

    // Start of user code class_attributes
    private static final Logger LOGGER = LoggerFactory.getLogger(GitLabProject.class);
    private static GitLabManagerData gitLabManagerData;
    // End of user code
    
    
    // Start of user code class_methods

    private static Store buildStore(ServletContext servletContext) {
        Store store = null;
        //store = StoreFactory.onDisk(storeDir);
        //store = StoreFactory.inMemory();  // TODO allow switching the Store implementation
        try {
            store = StoreFactory.sparql("http://***REMOVED***/gitlab/query",
                    "http://***REMOVED***/gitlab/update");
            UpdateProcessor updateProcessor = store.removeAll();
            updateProcessor.execute();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return store;
    }

    // URL: ${base_url}/gitlab/services/pn-services/PnSP/hookURLs/notifications/
    public static void addPushEvent(BufferedReader reader) {
        try {
            GitlabEventMessage message = null;
            JSONObject jsonObj = new JSONObject(reader);
            if (jsonObj.getString("object_kind").equals("push")) {
                message = new GitlabEventMessage("UNDEFINED_SP_ID",
                        GitlabEventMessage.GITLAB_EVENT.PUSH,
                        gitLabManagerData);
                message.setProjectID(jsonObj.getString("project_id"));
            } else if (jsonObj.getString("object_kind").equals("issue")) {
                message = new GitlabEventMessage("UNDEFINED_SP_ID",
                        GitlabEventMessage.GITLAB_EVENT.ISSUE,
                        gitLabManagerData);
                message.setIssueID(jsonObj.getJSONObject("object_attributes").getString("id"));
                String status = jsonObj.getJSONObject("object_attributes").getString("action");
                if (status.equals("open")) {
                    message.setIssue_status(GitlabEventMessage.ISSUE_STATUS.ISSUE_CREATED);
                } else if (status.equals("update")) {
                    message.setIssue_status(GitlabEventMessage.ISSUE_STATUS.ISSUE_UPDATED);
                } else if (status.equals("close")) {
                    message.setIssue_status(GitlabEventMessage.ISSUE_STATUS.ISSUE_CLOSED);
                } else if (status.equals("reopen")) {
                    message.setIssue_status(GitlabEventMessage.ISSUE_STATUS.ISSUE_REOPENED);
                }
                String projectName = jsonObj.getJSONObject("project").getString("name");
                message.setProjectID(gitLabManagerData.getGitLabProjects().get(projectName).gitlabProject.getId().toString());
            }
            message.setProjectName(jsonObj.getJSONObject("project").getString("name"));
            message.setGitLabManagerData(gitLabManagerData);
            ZonedDateTime zd = ZonedDateTime.now();
            Optional<GitlabEventMessage> m = Optional.of(message);
            gitLabManagerData.getGitLabUpdateManager().submit(zd, m);
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    private static <T> List<T> slicePaging(List<T> resources, int page, int limit) {
        if (limit <= 0) {
            return resources;
        }
        int fromIndex = page * limit;
        // override due to a bug in service that determines paging flag,
        // it removes the last element if there are more than 'limit' records
        int limitIndex = fromIndex + limit + 1; // TODO: 2016-12-26 remove +1 workaround
        int toIndex = Math.min(limitIndex, resources.size());
        LOGGER.trace("Creating a slice [{},{}] on a list of {} elements", fromIndex, toIndex, resources.size());
        // because service calls .remove() method that is not defined on some immutable implementations
        // TODO: 2016-12-25 fix in the generator to call subList(0, size-1)
        return new ArrayList<>(resources.subList(fromIndex, toIndex));
    }

    // End of user code

    public static void contextInitializeServletListener(final ServletContextEvent servletContextEvent)
    {
        
        // Start of user code contextInitializeServletListener
        ServletContext context = servletContextEvent.getServletContext();
        String gitLabToken = context.getInitParameter("se.kth.md.assume.adaptors.gitlab.token");
        String gitLabURL = context.getInitParameter("se.kth.md.assume.adaptors.gitlab.url");
        String reposRootFolder = context.getInitParameter("se.kth.md.assume.adaptors.gitlab.servlet.root.repository.dir");
        String baseURL = context.getInitParameter("se.kth.md.assume.adaptors.gitlab.servlet.baseurl");
        String projectsToExposeParam = context.getInitParameter("se.kth.md.assume.adaptors.gitlab.projects");
        String projectsNamespace = context.getInitParameter("se.kth.md.assume.adaptors.gitlab.group");

        gitLabManagerData = new GitLabManagerData(gitLabToken, gitLabURL, baseURL, projectsToExposeParam);

        Store store = buildStore(context);
        gitLabManagerData.setStore(store);

        gitLabManagerData.initializeUserList(projectsNamespace);
        gitLabManagerData.initializeGitLabProjects(reposRootFolder);

        // Check that we don't miss any events during the deployment phase?
        gitLabManagerData.initializeGitlabUpdateManager();

        gitLabManagerData.initResourceExtraction();

        // End of user code
    }

    public static void contextDestroyServletListener(ServletContextEvent servletContextEvent) 
    {
        
        // Start of user code contextDestroyed
        // TODO Implement code to shutdown connections to data backbone etc...
        // End of user code
    }

    public static FmServicesServiceProviderInfo[] getFmServicesServiceProviderInfos(HttpServletRequest httpServletRequest)
    {
        FmServicesServiceProviderInfo[] serviceProviderInfos = {};
        
        // Start of user code "FmServicesServiceProviderInfo[] getFmServicesServiceProviderInfos(...)"

        List<FmServicesServiceProviderInfo> infos = new ArrayList<>();
        FmServicesServiceProviderInfo spInfo;
        for (GitLabManagerData.GitLabProjectInfos pInfo : gitLabManagerData.getGitLabProjects().values()) {
            ServiceProvider sp = pInfo.serviceProvider;
            spInfo = new FmServicesServiceProviderInfo();
            spInfo.serviceProviderId = sp.getTitle();
            spInfo.name = sp.getTitle();
            infos.add(spInfo);
        }
        serviceProviderInfos = infos.toArray(new FmServicesServiceProviderInfo[infos.size()]);

        // End of user code
        return serviceProviderInfos;
    }
    public static PmServicesServiceProviderInfo[] getPmServicesServiceProviderInfos(HttpServletRequest httpServletRequest)
    {
        PmServicesServiceProviderInfo[] serviceProviderInfos = {};
        
        // Start of user code "PmServicesServiceProviderInfo[] getPmServicesServiceProviderInfos(...)"
        PmServicesServiceProviderInfo spiPM = new PmServicesServiceProviderInfo();
        spiPM.serviceProviderId = GitLabConstants.PROJECT_MANAGEMENT_SERVICE_PROVIDER_ID;
        spiPM.name = GitLabConstants.PROJECT_MANAGEMENT_SERVICE_PROVIDER_ID;

        serviceProviderInfos = new PmServicesServiceProviderInfo[]{spiPM};

        // End of user code
        return serviceProviderInfos;
    }
    public static CmServicesServiceProviderInfo[] getCmServicesServiceProviderInfos(HttpServletRequest httpServletRequest)
    {
        CmServicesServiceProviderInfo[] serviceProviderInfos = {};
        
        // Start of user code "CmServicesServiceProviderInfo[] getCmServicesServiceProviderInfos(...)"
        CmServicesServiceProviderInfo spiCM = new CmServicesServiceProviderInfo();
        spiCM.serviceProviderId = GitLabConstants.CHANGE_MANAGEMENT_SERVICE_PROVIDER_ID;
        spiCM.name = GitLabConstants.CHANGE_MANAGEMENT_SERVICE_PROVIDER_ID;

        serviceProviderInfos = new CmServicesServiceProviderInfo[]{spiCM};
        // End of user code
        return serviceProviderInfos;
    }
    public static PnServicesServiceProviderInfo[] getPnServicesServiceProviderInfos(HttpServletRequest httpServletRequest)
    {
        PnServicesServiceProviderInfo[] serviceProviderInfos = {};
        
        // Start of user code "PnServicesServiceProviderInfo[] getPnServicesServiceProviderInfos(...)"
        PnServicesServiceProviderInfo spiPn = new PnServicesServiceProviderInfo();
        spiPn.serviceProviderId = GitLabConstants.PUSH_NOTIFICATIONS_SERVICE_PROVIDER_ID;
        spiPn.name = GitLabConstants.PUSH_NOTIFICATIONS_SERVICE_PROVIDER_ID;

        serviceProviderInfos = new PnServicesServiceProviderInfo[]{spiPn};
        // End of user code
        return serviceProviderInfos;
    }

    public static List<VersionResource> queryVersionResources(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<VersionResource> resources = null;
        
        // Start of user code queryVersionResources
        try {
            URI uri = URI.create(ResourceVersionHandler.getVersionResourceGraphName(serviceProviderId));
            resources = gitLabManagerData.getStore().getResources(uri, VersionResource.class);
            resources = slicePaging(resources, page, limit);
        } catch (StoreAccessException | ModelUnmarshallingException e) {
            e.printStackTrace();
        }
        // End of user code
        return resources;
    }
    public static List<FileResource> queryFileResources(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<FileResource> resources = null;
        
        // Start of user code queryFileResources
        try {
            // TODO: paging and checks...
            // TODO: Maybe there is no need to expose a queryCapability for all the files,
            // but only provide an access to them via the "contains" subject of the projects.
            //RepositoryResourceManager<FileResource> repositoryResourceManager = gitLabProjects.get(serviceProviderId).repositoryManager;
            RepositoryResourceManager<FileResource> repositoryResourceManager = gitLabManagerData.getGitLabProjects().get(serviceProviderId).repositoryManager;
            Revision currentRevision = repositoryResourceManager.getCurrentRevision();
            URI key = null;
            try {
                key = repositoryResourceManager.key(serviceProviderId, currentRevision);
            } catch (ExecutionException e) {
                e.printStackTrace();
            }
            resources = gitLabManagerData.getStore().getResources(
                    key,
                    FileResource.class);
        } catch (StoreAccessException e) {
            e.printStackTrace();
        } catch (ModelUnmarshallingException e) {
            e.printStackTrace();
        }
        // End of user code
        return resources;
    }
    public static List<FolderResource> queryFolderResources(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<FolderResource> resources = null;
        
        // Start of user code queryFolderResources
        // TODO Implement code to return a set of resources
        // End of user code
        return resources;
    }
    public static List<FileResource> FileResourceSelector(HttpServletRequest httpServletRequest, final String serviceProviderId, String terms)   
    {
        List<FileResource> resources = null;
        
        // Start of user code FileResourceSelector
        // TODO Implement code to return a set of resources, based on search criteria 
        // End of user code
        return resources;
    }


    public static VersionResource getVersionResource(HttpServletRequest httpServletRequest, final String serviceProviderId, final String resourceId)
    {
        VersionResource aResource = null;
        
        // Start of user code getVersionResource
        URI serviceProviderURI = ServiceProviderCatalogSingleton.constructFmServicesServiceProviderURI(serviceProviderId);
        URI uriToRetrieve = GitLabProject.constructURI(serviceProviderId, resourceId);
        try {
            aResource = gitLabManagerData.getStore().getResourceUnderKey(serviceProviderURI, uriToRetrieve, VersionResource.class);
        } catch (StoreAccessException e) {
            e.printStackTrace();
        } catch (ModelUnmarshallingException e) {
            e.printStackTrace();
        }
        // End of user code
        return aResource;
    }
    public static FileResource getFileResource(HttpServletRequest httpServletRequest, final String serviceProviderId, final String resourceId)
    {
        FileResource aResource = null;
        
        // Start of user code getFileResource
        //String projectName = serviceProviderId.substring(GitLabConstants.FILE_MANAGEMENT_SERVICE_PROVIDER_ID.length() + 1);
        String projectName = serviceProviderId;
        RepositoryResourceManager<FileResource> repositoryResourceManager =
                gitLabManagerData.getGitLabProjects().get(projectName).repositoryManager;
        Revision currentRevision = repositoryResourceManager.getCurrentRevision();
        try {
            URI key = repositoryResourceManager.key(serviceProviderId, currentRevision);
            URI id = FileResource.constructURI(serviceProviderId, resourceId);
            try {
                aResource = gitLabManagerData.getStore().getResourceUnderKey(key, id, FileResource.class);
            } catch (StoreAccessException e) {
                e.printStackTrace();
            } catch (ModelUnmarshallingException e) {
                e.printStackTrace();
            }
        } catch (ExecutionException e) {
            e.printStackTrace();
        }
        // End of user code
        return aResource;
    }
    public static FolderResource getFolderResource(HttpServletRequest httpServletRequest, final String serviceProviderId, final String resourceId)
    {
        FolderResource aResource = null;
        
        // Start of user code getFolderResource
        // TODO Implement code to return a resource
        // End of user code
        return aResource;
    }



    public static List<GitLabProject> queryGitLabProjects(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<GitLabProject> resources = null;
        
        // Start of user code queryGitLabProjects
        URI serviceProviderURI = ServiceProviderCatalogSingleton.constructPmServicesServiceProviderURI(GitLabConstants.PROJECT_MANAGEMENT_SERVICE_PROVIDER_ID);
        try {
            resources = gitLabManagerData.getStore().getResources(serviceProviderURI, GitLabProject.class);
            resources = new ArrayList<>(resources);
        } catch (StoreAccessException e) {
            e.printStackTrace();
        } catch (ModelUnmarshallingException e) {
            e.printStackTrace();
        }
        // End of user code
        return resources;
    }


    public static GitLabProject getGitLabProject(HttpServletRequest httpServletRequest, final String serviceProviderId, final String projectName)
    {
        GitLabProject aResource = null;
        
        // Start of user code getGitLabProject
        aResource = ResourceExtractorHelper.getGitLabProjectFromStore(gitLabManagerData.getStore(), serviceProviderId, projectName);
        // End of user code
        return aResource;
    }



    public static List<ChangeRequest> queryChangeRequests(HttpServletRequest httpServletRequest, final String serviceProviderId, String where, int page, int limit)
    {
        List<ChangeRequest> resources = null;
        
        // Start of user code queryChangeRequests
        URI serviceProviderURI = ServiceProviderCatalogSingleton.constructCmServicesServiceProviderURI(GitLabConstants.CHANGE_MANAGEMENT_SERVICE_PROVIDER_ID);
        try {
            resources = gitLabManagerData.getStore().getResources(serviceProviderURI, ChangeRequest.class);
            resources = new ArrayList<>(resources);
        } catch (StoreAccessException e) {
            e.printStackTrace();
        } catch (ModelUnmarshallingException e) {
            e.printStackTrace();
        }
        // End of user code
        return resources;
    }


    public static ChangeRequest getChangeRequest(HttpServletRequest httpServletRequest, final String serviceProviderId, final String resourceId)
    {
        ChangeRequest aResource = null;
        
        // Start of user code getChangeRequest
        aResource = ResourceExtractorHelper.getChangeRequestFromStore(gitLabManagerData.getStore(), serviceProviderId, resourceId);
        // End of user code
        return aResource;
    }





    public static HookURL getHookURL(HttpServletRequest httpServletRequest, final String serviceProviderId, final String hookURLId)
    {
        HookURL aResource = null;
        
        // Start of user code getHookURL
        // TODO Implement code to return a resource
        // End of user code
        return aResource;
    }




    public static String getETagFromChangeRequest(final ChangeRequest aResource)
    {
        String eTag = null;
        // Start of user code getETagFromChangeRequest
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
    public static String getETagFromFileResource(final FileResource aResource)
    {
        String eTag = null;
        // Start of user code getETagFromFileResource
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
    public static String getETagFromFolderResource(final FolderResource aResource)
    {
        String eTag = null;
        // Start of user code getETagFromFolderResource
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
    public static String getETagFromVersionResource(final VersionResource aResource)
    {
        String eTag = null;
        // Start of user code getETagFromVersionResource
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
    public static String getETagFromHookURL(final HookURL aResource)
    {
        String eTag = null;
        // Start of user code getETagFromHookURL
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
    public static String getETagFromGitLabProject(final GitLabProject aResource)
    {
        String eTag = null;
        // Start of user code getETagFromGitLabProject
        // TODO Implement code to return an ETag for a particular resource
        // End of user code
        return eTag;
    }
}
